Xerces-J API: Class BaseMarkupSerializer

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xml.serialize
Class BaseMarkupSerializer

    java.lang.Object
      |
      +--org.apache.xml.serialize.BaseMarkupSerializer

Direct Known Subclasses:
  HTMLSerializer, TextSerializer, XMLSerializer

public abstract class BaseMarkupSerializer
extends java.lang.Object
implements ContentHandler, DocumentHandler, LexicalHandler, DTDHandler, DeclHandler, DOMSerializer, Serializer

Base class for a serializer supporting both DOM and SAX pretty serializing of XML/HTML/XHTML documents. Derives classes perform the method-specific serializing, this class provides the common serializing mechanisms.

The serializer must be initialized with the proper writer and output format before it can be used by calling `#init`. The serializer can be reused any number of times, but cannot be used concurrently by two threads.

If an output stream is used, the encoding is taken from the output format (defaults to `UTF-8`). If a writer is used, make sure the writer uses the same encoding (if applies) as specified in the output format.

The serializer supports both DOM and SAX. DOM serializing is done by calling `serialize(org.w3c.dom.Element)` and SAX serializing is done by firing SAX events and using the serializer as a document handler. This also applies to derived class.

If an I/O exception occurs while serializing, the serializer will not throw an exception directly, but only throw it at the end of serializing (either DOM or SAX's `DocumentHandler.endDocument()`.

For elements that are not specified as whitespace preserving, the serializer will potentially break long text lines at space boundaries, indent lines, and serialize elements on separate lines. Line terminators will be regarded as spaces, and spaces at beginning of line will be stripped.

When indenting, the serializer is capable of detecting seemingly element content, and serializing these elements indented on separate lines. An element is serialized indented when it is the first or last child of an element, or immediate following or preceding another element.

Version:
  $Revision: 1.26 $ $Date: 2001/07/11 15:40:10 $
Author:
  Assaf Arkin
See Also:
  `Serializer`, `DOMSerializer`

Field Summary
`protected java.lang.String` | `_docTypePublicId` The system identifier of the document type, if known.
`protected java.lang.String` | `_docTypeSystemId` The system identifier of the document type, if known.
`protected OutputFormat` | `_format` The output format associated with this serializer.
`protected boolean` | `_indenting` True if indenting printer.
`protected java.util.Hashtable` | `_prefixes` Association between namespace URIs (keys) and prefixes (values).
`protected Printer` | `_printer` The printer used for printing text parts.
`protected boolean` | `_started` If the document has been started (header serialized), this flag is set to true so it's not started twice.

Constructor Summary
`protected` | `BaseMarkupSerializer(OutputFormat format)` Protected constructor can only be used by derived class.

Method Summary
`ContentHandler` | `asContentHandler()` Return a `ContentHandler` interface into this serializer.
`DocumentHandler` | `asDocumentHandler()` Return a `DocumentHandler` interface into this serializer.
`DOMSerializer` | `asDOMSerializer()` Return a `DOMSerializer` interface into this serializer.
`void` | `attributeDecl(java.lang.String eName, java.lang.String aName, java.lang.String type, java.lang.String valueDefault, java.lang.String value)` Report an attribute type declaration.
`void` | `characters(char[] chars, int start, int length)` Receive notification of character data.
`protected void` | `characters(java.lang.String text)` Called to print the text contents in the prevailing element format.
`void` | `comment(char[] chars, int start, int length)` Report an XML comment anywhere in the document.
`void` | `comment(java.lang.String text)`
`protected ElementState` | `content()` Must be called by a method about to print any type of content.
`void` | `elementDecl(java.lang.String name, java.lang.String model)` Report an element type declaration.
`void` | `endCDATA()` Report the end of a CDATA section.
`void` | `endDocument()` Called at the end of the document to wrap it up.
`void` | `endDTD()` Report the end of DTD declarations.
`void` | `endEntity(java.lang.String name)` Report the end of an entity.
`void` | `endNonEscaping()`
`void` | `endPrefixMapping(java.lang.String prefix)` End the scope of a prefix-URI mapping.
`void` | `endPreserving()`
`protected ElementState` | `enterElementState(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName, boolean preserveSpace)` Enter a new element state for the specified element.
`void` | `externalEntityDecl(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` Report a parsed external entity declaration.
`protected ElementState` | `getElementState()` Return the state of the current element.
`protected abstract java.lang.String` | `getEntityRef(int ch)` Returns the suitable entity reference for this character value, or null if no such entity exists.
`protected java.lang.String` | `getPrefix(java.lang.String namespaceURI)` Returns the namespace prefix for the specified URI.
`void` | `ignorableWhitespace(char[] chars, int start, int length)` Receive notification of ignorable whitespace in element content.
`void` | `internalEntityDecl(java.lang.String name, java.lang.String value)` Report an internal entity declaration.
`protected boolean` | `isDocumentState()` Returns true if in the state of the document.
`protected ElementState` | `leaveElementState()` Leave the current element state and return to the state of the parent element.
`void` | `notationDecl(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` Receive notification of a notation declaration event.
`protected void` | `prepare()`
`protected void` | `printDoctypeURL(java.lang.String url)` Print a document type public or system identifier URL.
`protected void` | `printEscaped(int ch)`
`protected void` | `printEscaped(java.lang.String source)` Escapes a string so it may be printed as text content or attribute value.
`protected void` | `printText(char[] chars, int start, int length, boolean preserveSpace, boolean unescaped)` Called to print additional text with whitespace handling.
`protected void` | `printText(java.lang.String text, boolean preserveSpace, boolean unescaped)`
`void` | `processingInstruction(java.lang.String target, java.lang.String code)` Receive notification of a processing instruction.
`void` | `processingInstructionIO(java.lang.String target, java.lang.String code)`
`boolean` | `reset()`
`void` | `serialize(Document doc)` Serializes the DOM document using the previously specified writer and output format.
`void` | `serialize(DocumentFragment frag)` Serializes the DOM document fragmnt using the previously specified writer and output format.
`void` | `serialize(Element elem)` Serializes the DOM element using the previously specified writer and output format.
`protected abstract void` | `serializeElement(Element elem)` Called to serializee the DOM element.
`protected void` | `serializeNode(Node node)` Serialize the DOM node.
`protected void` | `serializePreRoot()` Comments and PIs cannot be serialized before the root element, because the root element serializes the document type, which generally comes first.
`void` | `setDocumentLocator(Locator locator)` Receive an object for locating the origin of SAX document events.
`void` | `setOutputByteStream(java.io.OutputStream output)` Specifies an output stream to which the document should be serialized.
`void` | `setOutputCharStream(java.io.Writer writer)` Specifies a writer to which the document should be serialized.
`void` | `setOutputFormat(OutputFormat format)` Specifies an output format for this serializer.
`void` | `skippedEntity(java.lang.String name)` Receive notification of a skipped entity.
`void` | `startCDATA()` Report the start of a CDATA section.
`void` | `startDocument()` Receive notification of the beginning of a document.
`void` | `startDTD(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` Report the start of DTD declarations, if any.
`void` | `startEntity(java.lang.String name)` Report the beginning of some internal and external XML entities.
`void` | `startNonEscaping()`
`void` | `startPrefixMapping(java.lang.String prefix, java.lang.String uri)` Begin the scope of a prefix-URI Namespace mapping.
`void` | `startPreserving()`
`void` | `unparsedEntityDecl(java.lang.String name, java.lang.String publicId, java.lang.String systemId, java.lang.String notationName)` Receive notification of an unparsed entity declaration event.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _started

    protected boolean _started

  If the document has been started (header serialized), this flag is set to true so it's not started twice.

### _prefixes

    protected java.util.Hashtable _prefixes

  Association between namespace URIs (keys) and prefixes (values). Accumulated here prior to starting an element and placing this list in the element state.

### _docTypePublicId

    protected java.lang.String _docTypePublicId

  The system identifier of the document type, if known.

### _docTypeSystemId

    protected java.lang.String _docTypeSystemId

  The system identifier of the document type, if known.

### _format

    protected OutputFormat _format

  The output format associated with this serializer. This will never be a null reference. If no format was passed to the constructor, the default one for this document type will be used. The format object is never changed by the serializer.

### _printer

    protected Printer _printer

  The printer used for printing text parts.

### _indenting

    protected boolean _indenting

  True if indenting printer.

Constructor Detail

### BaseMarkupSerializer

    protected BaseMarkupSerializer(OutputFormat format)

  Protected constructor can only be used by derived class. Must initialize the serializer before serializing any document, see `#init`.

Method Detail

### asDocumentHandler

    public DocumentHandler asDocumentHandler()
                                      throws java.io.IOException

  Description copied from interface: Serializer
  Return a `DocumentHandler` interface into this serializer. If the serializer does not support the `DocumentHandler` interface, it should return null.
  Specified by:
    asDocumentHandler in interface Serializer

### asContentHandler

    public ContentHandler asContentHandler()
                                    throws java.io.IOException

  Description copied from interface: Serializer
  Return a `ContentHandler` interface into this serializer. If the serializer does not support the `ContentHandler` interface, it should return null.
  Specified by:
    asContentHandler in interface Serializer

### asDOMSerializer

    public DOMSerializer asDOMSerializer()
                                  throws java.io.IOException

  Description copied from interface: Serializer
  Return a `DOMSerializer` interface into this serializer. If the serializer does not support the `DOMSerializer` interface, it should return null.
  Specified by:
    asDOMSerializer in interface Serializer

### setOutputByteStream

    public void setOutputByteStream(java.io.OutputStream output)

  Description copied from interface: Serializer
  Specifies an output stream to which the document should be serialized. This method should not be called while the serializer is in the process of serializing a document.
  Specified by:
    setOutputByteStream in interface Serializer

### setOutputCharStream

    public void setOutputCharStream(java.io.Writer writer)

  Description copied from interface: Serializer
  Specifies a writer to which the document should be serialized. This method should not be called while the serializer is in the process of serializing a document.
  Specified by:
    setOutputCharStream in interface Serializer

### setOutputFormat

    public void setOutputFormat(OutputFormat format)

  Description copied from interface: Serializer
  Specifies an output format for this serializer. It the serializer has already been associated with an output format, it will switch to the new format. This method should not be called while the serializer is in the process of serializing a document.
  Specified by:
    setOutputFormat in interface Serializer
  Tags copied from interface: Serializer
  Parameters:
    `format` - The output format to use

### reset

    public boolean reset()

### prepare

    protected void prepare()
                    throws java.io.IOException

### serialize

    public void serialize(Element elem)
                   throws java.io.IOException

  Serializes the DOM element using the previously specified writer and output format. Throws an exception only if an I/O exception occured while serializing.
  Specified by:
    serialize in interface DOMSerializer
  Parameters:
    `elem` - The element to serialize
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### serialize

    public void serialize(DocumentFragment frag)
                   throws java.io.IOException

  Serializes the DOM document fragmnt using the previously specified writer and output format. Throws an exception only if an I/O exception occured while serializing.
  Specified by:
    serialize in interface DOMSerializer
  Parameters:
    `elem` - The element to serialize
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### serialize

    public void serialize(Document doc)
                   throws java.io.IOException

  Serializes the DOM document using the previously specified writer and output format. Throws an exception only if an I/O exception occured while serializing.
  Specified by:
    serialize in interface DOMSerializer
  Parameters:
    `doc` - The document to serialize
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### startDocument

    public void startDocument()
                       throws SAXException

  Description copied from interface: ContentHandler
  Receive notification of the beginning of a document.

  The SAX parser will invoke this method only once, before any other methods in this interface or in `DTDHandler` (except for `setDocumentLocator`).

  Specified by:
    startDocument in interface ContentHandler
  Tags copied from interface: ContentHandler
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.endDocument()`

### characters

    public void characters(char[] chars,
                           int start,
                           int length)
                    throws SAXException

  Description copied from interface: ContentHandler
  Receive notification of character data.

  The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity so that the Locator provides useful information.

  The application must not attempt to read from the array outside of the specified range.

  Note that some parsers will report whitespace in element content using the `ignorableWhitespace` method rather than this one (validating parsers must do so).

  Specified by:
    characters in interface ContentHandler
  Tags copied from interface: ContentHandler
  Parameters:
    `ch` - The characters from the XML document.
    `start` - The start position in the array.
    `length` - The number of characters to read from the array.
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.ignorableWhitespace(char[], int, int)`, `Locator`

### ignorableWhitespace

    public void ignorableWhitespace(char[] chars,
                                    int start,
                                    int length)
                             throws SAXException

  Description copied from interface: ContentHandler
  Receive notification of ignorable whitespace in element content.

  Validating Parsers must use this method to report each chunk of whitespace in element content (see the W3C XML 1.0 recommendation, section 2.10): non-validating parsers may also use this method if they are capable of parsing and using content models.

  SAX parsers may return all contiguous whitespace in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity, so that the Locator provides useful information.

  The application must not attempt to read from the array outside of the specified range.

  Specified by:
    ignorableWhitespace in interface ContentHandler
  Tags copied from interface: ContentHandler
  Parameters:
    `ch` - The characters from the XML document.
    `start` - The start position in the array.
    `length` - The number of characters to read from the array.
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.characters(char[], int, int)`

### processingInstruction

    public final void processingInstruction(java.lang.String target,
                                            java.lang.String code)
                                     throws SAXException

  Description copied from interface: ContentHandler
  Receive notification of a processing instruction.

  The Parser will invoke this method once for each processing instruction found: note that processing instructions may occur before or after the main document element.

  A SAX parser must never report an XML declaration (XML 1.0, section 2.8) or a text declaration (XML 1.0, section 4.3.1) using this method.

  Specified by:
    processingInstruction in interface ContentHandler
  Tags copied from interface: ContentHandler
  Parameters:
    `target` - The processing instruction target.
    `data` - The processing instruction data, or null if none was supplied. The data does not include any whitespace separating it from the target.
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.

### processingInstructionIO

    public void processingInstructionIO(java.lang.String target,
                                        java.lang.String code)
                                 throws java.io.IOException

### comment

    public void comment(char[] chars,
                        int start,
                        int length)
                 throws SAXException

  Description copied from interface: LexicalHandler
  Report an XML comment anywhere in the document.

  This callback will be used for comments inside or outside the document element, including comments in the external DTD subset (if read). Comments in the DTD must be properly nested inside start/endDTD and start/endEntity events (if used).

  Specified by:
    comment in interface LexicalHandler
  Tags copied from interface: LexicalHandler
  Parameters:
    `ch` - An array holding the characters in the comment.
    `start` - The starting position in the array.
    `length` - The number of characters to use from the array.
  Throws:
    SAXException - The application may raise an exception.

### comment

    public void comment(java.lang.String text)
                 throws java.io.IOException

### startCDATA

    public void startCDATA()

  Description copied from interface: LexicalHandler
  Report the start of a CDATA section.

  The contents of the CDATA section will be reported through the regular `characters` event; this event is intended only to report the boundary.

  Specified by:
    startCDATA in interface LexicalHandler
  Tags copied from interface: LexicalHandler
  Throws:
    SAXException - The application may raise an exception.
  See Also:
    `LexicalHandler.endCDATA()`

### endCDATA

    public void endCDATA()

  Description copied from interface: LexicalHandler
  Report the end of a CDATA section.
  Specified by:
    endCDATA in interface LexicalHandler
  Tags copied from interface: LexicalHandler
  Throws:
    SAXException - The application may raise an exception.
  See Also:
    `LexicalHandler.startCDATA()`

### startNonEscaping

    public void startNonEscaping()

### endNonEscaping

    public void endNonEscaping()

### startPreserving

    public void startPreserving()

### endPreserving

    public void endPreserving()

### endDocument

    public void endDocument()
                     throws SAXException

  Called at the end of the document to wrap it up. Will flush the output stream and throw an exception if any I/O error occured while serializing.
  Specified by:
    endDocument in interface ContentHandler
  Throws:
    SAXException - An I/O exception occured during serializing

### startEntity

    public void startEntity(java.lang.String name)

  Description copied from interface: LexicalHandler
  Report the beginning of some internal and external XML entities.

  The reporting of parameter entities (including the external DTD subset) is optional, and SAX2 drivers that support LexicalHandler may not support it; you can use the `http://xml.org/sax/features/lexical-handler/parameter-entities` feature to query or control the reporting of parameter entities.

  General entities are reported with their regular names, parameter entities have '%' prepended to their names, and the external DTD subset has the pseudo-entity name "[dtd]".

  When a SAX2 driver is providing these events, all other events must be properly nested within start/end entity events. There is no additional requirement that events from `DeclHandler` or `DTDHandler` be properly ordered.

  Note that skipped entities will be reported through the `skippedEntity` event, which is part of the ContentHandler interface.

  Because of the streaming event model that SAX uses, some entity boundaries cannot be reported under any circumstances:

  - general entities within attribute values
  - parameter entities within declarations

  These will be silently expanded, with no indication of where the original entity boundaries were.

  Note also that the boundaries of character references (which are not really entities anyway) are not reported.

  All start/endEntity events must be properly nested.

  Specified by:
    startEntity in interface LexicalHandler
  Tags copied from interface: LexicalHandler
  Parameters:
    `name` - The name of the entity. If it is a parameter entity, the name will begin with '%', and if it is the external DTD subset, it will be "[dtd]".
  Throws:
    SAXException - The application may raise an exception.
  See Also:
    `LexicalHandler.endEntity(java.lang.String)`, `DeclHandler.internalEntityDecl(java.lang.String, java.lang.String)`, `DeclHandler.externalEntityDecl(java.lang.String, java.lang.String, java.lang.String)`

### endEntity

    public void endEntity(java.lang.String name)

  Description copied from interface: LexicalHandler
  Report the end of an entity.
  Specified by:
    endEntity in interface LexicalHandler
  Tags copied from interface: LexicalHandler
  Parameters:
    `name` - The name of the entity that is ending.
  Throws:
    SAXException - The application may raise an exception.
  See Also:
    `LexicalHandler.startEntity(java.lang.String)`

### setDocumentLocator

    public void setDocumentLocator(Locator locator)

  Description copied from interface: ContentHandler
  Receive an object for locating the origin of SAX document events.

  SAX parsers are strongly encouraged (though not absolutely required) to supply a locator: if it does so, it must supply the locator to the application by invoking this method before invoking any of the other methods in the ContentHandler interface.

  The locator allows the application to determine the end position of any document-related event, even if the parser is not reporting an error. Typically, the application will use this information for reporting its own errors (such as character content that does not match an application's business rules). The information returned by the locator is probably not sufficient for use with a search engine.

  Note that the locator will return correct information only during the invocation of the events in this interface. The application should not attempt to use it at any other time.

  Specified by:
    setDocumentLocator in interface ContentHandler
  Tags copied from interface: ContentHandler
  Parameters:
    `locator` - An object that can return the location of any SAX document event.
  See Also:
    `Locator`

### skippedEntity

    public void skippedEntity(java.lang.String name)
                       throws SAXException

  Description copied from interface: ContentHandler
  Receive notification of a skipped entity.

  The Parser will invoke this method once for each entity skipped. Non-validating processors may skip entities if they have not seen the declarations (because, for example, the entity was declared in an external DTD subset). All processors may skip external entities, depending on the values of the `http://xml.org/sax/features/external-general-entities` and the `http://xml.org/sax/features/external-parameter-entities` properties.

  Specified by:
    skippedEntity in interface ContentHandler
  Tags copied from interface: ContentHandler
  Parameters:
    `name` - The name of the skipped entity. If it is a parameter entity, the name will begin with '%', and if it is the external DTD subset, it will be the string "[dtd]".
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.

### startPrefixMapping

    public void startPrefixMapping(java.lang.String prefix,
                                   java.lang.String uri)
                            throws SAXException

  Description copied from interface: ContentHandler
  Begin the scope of a prefix-URI Namespace mapping.

  The information from this event is not necessary for normal Namespace processing: the SAX XML reader will automatically replace prefixes for element and attribute names when the `http://xml.org/sax/features/namespaces` feature is true (the default).

  There are cases, however, when applications need to use prefixes in character data or in attribute values, where they cannot safely be expanded automatically; the start/endPrefixMapping event supplies the information to the application to expand prefixes in those contexts itself, if necessary.

  Note that start/endPrefixMapping events are not guaranteed to be properly nested relative to each-other: all startPrefixMapping events will occur before the corresponding `startElement` event, and all `endPrefixMapping` events will occur after the corresponding `endElement` event, but their order is not otherwise guaranteed.

  There should never be start/endPrefixMapping events for the "xml" prefix, since it is predeclared and immutable.

  Specified by:
    startPrefixMapping in interface ContentHandler
  Tags copied from interface: ContentHandler
  Parameters:
    `prefix` - The Namespace prefix being declared.
    `uri` - The Namespace URI the prefix is mapped to.
  Throws:
    SAXException - The client may throw an exception during processing.
  See Also:
    `ContentHandler.endPrefixMapping(java.lang.String)`, `ContentHandler.startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`

### endPrefixMapping

    public void endPrefixMapping(java.lang.String prefix)
                          throws SAXException

  Description copied from interface: ContentHandler
  End the scope of a prefix-URI mapping.

  See `startPrefixMapping` for details. This event will always occur after the corresponding `endElement` event, but the order of `endPrefixMapping` events is not otherwise guaranteed.

  Specified by:
    endPrefixMapping in interface ContentHandler
  Tags copied from interface: ContentHandler
  Parameters:
    `prefix` - The prefix that was being mapping.
  Throws:
    SAXException - The client may throw an exception during processing.
  See Also:
    `ContentHandler.startPrefixMapping(java.lang.String, java.lang.String)`, `ContentHandler.endElement(java.lang.String, java.lang.String, java.lang.String)`

### startDTD

    public final void startDTD(java.lang.String name,
                               java.lang.String publicId,
                               java.lang.String systemId)
                        throws SAXException

  Description copied from interface: LexicalHandler
  Report the start of DTD declarations, if any.

  This method is intended to report the beginning of the DOCTYPE declaration; if the document has no DOCTYPE declaration, this method will not be invoked.

  All declarations reported through `DTDHandler` or `DeclHandler` events must appear between the startDTD and `endDTD` events. Declarations are assumed to belong to the internal DTD subset unless they appear between `startEntity` and `endEntity` events. Comments and processing instructions from the DTD should also be reported between the startDTD and endDTD events, in their original order of (logical) occurrence; they are not required to appear in their correct locations relative to DTDHandler or DeclHandler events, however.

  Note that the start/endDTD events will appear within the start/endDocument events from ContentHandler and before the first `startElement` event.

  Specified by:
    startDTD in interface LexicalHandler
  Tags copied from interface: LexicalHandler
  Parameters:
    `name` - The document type name.
    `publicId` - The declared public identifier for the external DTD subset, or null if none was declared.
    `systemId` - The declared system identifier for the external DTD subset, or null if none was declared.
  Throws:
    SAXException - The application may raise an exception.
  See Also:
    `LexicalHandler.endDTD()`, `LexicalHandler.startEntity(java.lang.String)`

### endDTD

    public void endDTD()

  Description copied from interface: LexicalHandler
  Report the end of DTD declarations.

  This method is intended to report the end of the DOCTYPE declaration; if the document has no DOCTYPE declaration, this method will not be invoked.

  Specified by:
    endDTD in interface LexicalHandler
  Tags copied from interface: LexicalHandler
  Throws:
    SAXException - The application may raise an exception.
  See Also:
    `LexicalHandler.startDTD(java.lang.String, java.lang.String, java.lang.String)`

### elementDecl

    public void elementDecl(java.lang.String name,
                            java.lang.String model)
                     throws SAXException

  Description copied from interface: DeclHandler
  Report an element type declaration.

  The content model will consist of the string "EMPTY", the string "ANY", or a parenthesised group, optionally followed by an occurrence indicator. The model will be normalized so that all parameter entities are fully resolved and all whitespace is removed,and will include the enclosing parentheses. Other normalization (such as removing redundant parentheses or simplifying occurrence indicators) is at the discretion of the parser.

  Specified by:
    elementDecl in interface DeclHandler
  Tags copied from interface: DeclHandler
  Parameters:
    `name` - The element type name.
    `model` - The content model as a normalized string.
  Throws:
    SAXException - The application may raise an exception.

### attributeDecl

    public void attributeDecl(java.lang.String eName,
                              java.lang.String aName,
                              java.lang.String type,
                              java.lang.String valueDefault,
                              java.lang.String value)
                       throws SAXException

  Description copied from interface: DeclHandler
  Report an attribute type declaration.

  Only the effective (first) declaration for an attribute will be reported. The type will be one of the strings "CDATA", "ID", "IDREF", "IDREFS", "NMTOKEN", "NMTOKENS", "ENTITY", "ENTITIES", a parenthesized token group with the separator "|" and all whitespace removed, or the word "NOTATION" followed by a space followed by a parenthesized token group with all whitespace removed.

  Any parameter entities in the attribute value will be expanded, but general entities will not.

  Specified by:
    attributeDecl in interface DeclHandler
  Tags copied from interface: DeclHandler
  Parameters:
    `eName` - The name of the associated element.
    `aName` - The name of the attribute.
    `type` - A string representing the attribute type.
    `valueDefault` - A string representing the attribute default ("#IMPLIED", "#REQUIRED", or "#FIXED") or null if none of these applies.
    `value` - A string representing the attribute's default value, or null if there is none.
  Throws:
    SAXException - The application may raise an exception.

### internalEntityDecl

    public void internalEntityDecl(java.lang.String name,
                                   java.lang.String value)
                            throws SAXException

  Description copied from interface: DeclHandler
  Report an internal entity declaration.

  Only the effective (first) declaration for each entity will be reported. All parameter entities in the value will be expanded, but general entities will not.

  Specified by:
    internalEntityDecl in interface DeclHandler
  Tags copied from interface: DeclHandler
  Parameters:
    `name` - The name of the entity. If it is a parameter entity, the name will begin with '%'.
    `value` - The replacement text of the entity.
  Throws:
    SAXException - The application may raise an exception.
  See Also:
    `DeclHandler.externalEntityDecl(java.lang.String, java.lang.String, java.lang.String)`, `DTDHandler.unparsedEntityDecl(java.lang.String, java.lang.String, java.lang.String, java.lang.String)`

### externalEntityDecl

    public void externalEntityDecl(java.lang.String name,
                                   java.lang.String publicId,
                                   java.lang.String systemId)
                            throws SAXException

  Description copied from interface: DeclHandler
  Report a parsed external entity declaration.

  Only the effective (first) declaration for each entity will be reported.

  Specified by:
    externalEntityDecl in interface DeclHandler
  Tags copied from interface: DeclHandler
  Parameters:
    `name` - The name of the entity. If it is a parameter entity, the name will begin with '%'.
    `publicId` - The declared public identifier of the entity, or null if none was declared.
    `systemId` - The declared system identifier of the entity.
  Throws:
    SAXException - The application may raise an exception.
  See Also:
    `DeclHandler.internalEntityDecl(java.lang.String, java.lang.String)`, `DTDHandler.unparsedEntityDecl(java.lang.String, java.lang.String, java.lang.String, java.lang.String)`

### unparsedEntityDecl

    public void unparsedEntityDecl(java.lang.String name,
                                   java.lang.String publicId,
                                   java.lang.String systemId,
                                   java.lang.String notationName)
                            throws SAXException

  Description copied from interface: DTDHandler
  Receive notification of an unparsed entity declaration event.

  Note that the notation name corresponds to a notation reported by the `notationDecl` event. It is up to the application to record the entity for later reference, if necessary.

  If the system identifier is a URL, the parser must resolve it fully before passing it to the application.

  Specified by:
    unparsedEntityDecl in interface DTDHandler
  Tags copied from interface: DTDHandler
  Parameters:
    `name` - The unparsed entity's name.
    `publicId` - The entity's public identifier, or null if none was given.
    `systemId` - The entity's system identifier.
    `notation` - name The name of the associated notation.
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.
  See Also:
    `DTDHandler.notationDecl(java.lang.String, java.lang.String, java.lang.String)`, `AttributeList`

### notationDecl

    public void notationDecl(java.lang.String name,
                             java.lang.String publicId,
                             java.lang.String systemId)
                      throws SAXException

  Description copied from interface: DTDHandler
  Receive notification of a notation declaration event.

  It is up to the application to record the notation for later reference, if necessary.

  At least one of publicId and systemId must be non-null. If a system identifier is present, and it is a URL, the SAX parser must resolve it fully before passing it to the application through this event.

  There is no guarantee that the notation declaration will be reported before any unparsed entities that use it.

  Specified by:
    notationDecl in interface DTDHandler
  Tags copied from interface: DTDHandler
  Parameters:
    `name` - The notation name.
    `publicId` - The notation's public identifier, or null if none was given.
    `systemId` - The notation's system identifier, or null if none was given.
  Throws:
    SAXException - Any SAX exception, possibly wrapping another exception.
  See Also:
    `DTDHandler.unparsedEntityDecl(java.lang.String, java.lang.String, java.lang.String, java.lang.String)`, `AttributeList`

### serializeNode

    protected void serializeNode(Node node)
                          throws java.io.IOException

  Serialize the DOM node. This method is shared across XML, HTML and XHTML serializers and the differences are masked out in a separate `serializeElement(org.w3c.dom.Element)`.
  Parameters:
    `node` - The node to serialize
  Throws:
    java.io.IOException - An I/O exception occured while serializing
  See Also:
    `serializeElement(org.w3c.dom.Element)`

### content

    protected ElementState content()
                            throws java.io.IOException

  Must be called by a method about to print any type of content. If the element was just opened, the opening tag is closed and will be matched to a closing tag. Returns the current element state with `empty` and `afterElement` set to false.
  Returns:
    The current element state
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### characters

    protected void characters(java.lang.String text)
                       throws java.io.IOException

  Called to print the text contents in the prevailing element format. Since this method is capable of printing text as CDATA, it is used for that purpose as well. White space handling is determined by the current element state. In addition, the output format can dictate whether the text is printed as CDATA or unescaped.
  Parameters:
    `text` - The text to print
    `unescaped` - True is should print unescaped
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### getEntityRef

    protected abstract java.lang.String getEntityRef(int ch)

  Returns the suitable entity reference for this character value, or null if no such entity exists. Calling this method with `'&'` will return `"&amp;"`.
  Parameters:
    `ch` - Character value
  Returns:
    Character entity name, or null

### serializeElement

    protected abstract void serializeElement(Element elem)
                                      throws java.io.IOException

  Called to serializee the DOM element. The element is serialized based on the serializer's method (XML, HTML, XHTML).
  Parameters:
    `elem` - The element to serialize
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### serializePreRoot

    protected void serializePreRoot()
                             throws java.io.IOException

  Comments and PIs cannot be serialized before the root element, because the root element serializes the document type, which generally comes first. Instead such PIs and comments are accumulated inside a vector and serialized by calling this method. Will be called when the root element is serialized and when the document finished serializing.
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### printText

    protected final void printText(char[] chars,
                                   int start,
                                   int length,
                                   boolean preserveSpace,
                                   boolean unescaped)
                            throws java.io.IOException

  Called to print additional text with whitespace handling. If spaces are preserved, the text is printed as if by calling `#printText(String)` with a call to `#breakLine` for each new line. If spaces are not preserved, the text is broken at space boundaries if longer than the line width; Multiple spaces are printed as such, but spaces at beginning of line are removed.
  Parameters:
    `text` - The text to print
    `preserveSpace` - Space preserving flag
    `unescaped` - Print unescaped

### printText

    protected final void printText(java.lang.String text,
                                   boolean preserveSpace,
                                   boolean unescaped)
                            throws java.io.IOException

### printDoctypeURL

    protected void printDoctypeURL(java.lang.String url)
                            throws java.io.IOException

  Print a document type public or system identifier URL. Encapsulates the URL in double quotes, escapes non-printing characters and print it equivalent to `printText(char[], int, int, boolean, boolean)`.
  Parameters:
    `url` - The document type url to print

### printEscaped

    protected void printEscaped(int ch)
                         throws java.io.IOException

### printEscaped

    protected void printEscaped(java.lang.String source)
                         throws java.io.IOException

  Escapes a string so it may be printed as text content or attribute value. Non printable characters are escaped using character references. Where the format specifies a deault entity reference, that reference is used (e.g. `&lt;`).
  Parameters:
    `source` - The string to escape

### getElementState

    protected ElementState getElementState()

  Return the state of the current element.
  Returns:
    Current element state

### enterElementState

    protected ElementState enterElementState(java.lang.String namespaceURI,
                                             java.lang.String localName,
                                             java.lang.String rawName,
                                             boolean preserveSpace)

  Enter a new element state for the specified element. Tag name and space preserving is specified, element state is initially empty.
  Returns:
    Current element state, or null

### leaveElementState

    protected ElementState leaveElementState()

  Leave the current element state and return to the state of the parent element. If this was the root element, return to the state of the document.
  Returns:
    Previous element state

### isDocumentState

    protected boolean isDocumentState()

  Returns true if in the state of the document. Returns true before entering any element and after leaving the root element.
  Returns:
    True if in the state of the document

### getPrefix

    protected java.lang.String getPrefix(java.lang.String namespaceURI)

  Returns the namespace prefix for the specified URI. If the URI has been mapped to a prefix, returns the prefix, otherwise returns null.
  Parameters:
    `namespaceURI` - The namespace URI
  Returns:
    The namespace prefix if known, or null

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2001 Apache XML Project. All Rights Reserved.